/*--------------------------------------------------------------------------------------------------
                                                                              eSuperTrend EA_1.1.mq4

//------------------------------------------------------------------------------------------------*/
//Inputs
extern string  _0_ = "---Indicators settings---";
extern int     SuperTrend_Period       = 10;   //SuperTrend ATR Period
extern double  SuperTrend_Multiplier   = 1.7;  //SuperTrend Multiplier
extern int     SuperTrend_TimeFrame    = 60;   //SuperTrend Timeframe
extern int     SuperTrend_Period2      = 10;   //SuperTrend ATR Period
extern double  SuperTrend_Multiplier2  = 1.7;  //SuperTrend Multiplier
extern int     SuperTrend_TimeFrame2   = 1440; //SuperTrend Timeframe

extern string  _1_ = "---Money Management settings---";
extern bool    UseEquity               = false; //If true - expert uses equity, false - uses balance.
extern double  RiskPercent             = 2.5;   //If 0 - it is used the "Lots" parameter.
extern double  Lots                    = 0;     //If 0 - it is used the minimal lots.
extern double  MaxLot                  = 0;     //Limit for maximal order lots.
extern double  CloseLotPercent         = 50;    //The lots percent of partly order closure.

extern double  LotMultiplier           = 1.0;   //Usual martin - addition to the Cumulative martin! It multiplies the cumulative value of the loss orders lots. 
                                                //If =0 it doesn't used. If =1.0 it doesn't multiplies.
extern int     CalcHistOrders          = 5;        //Cumulative martin! It Calculates the cumulative value of the loss orders volume for the determined number of closed orders.

extern string  _3_="---General Settings---";
extern bool    ReverseMode             = true;  //Reverse orders mode.
extern int     StopLoss                = -10;   //+\- pips to the indicator's support or resistance level.
                                                /*
                                                Indicator's support/resistance level doesn't used untill it appears in the right place
                                                and the position closure is yet controlled by the "ReverseModeSL" level in the "ReverseMode"=true.
                                                */
extern int     ReverseModeSL           = 60;    //Start StopLoss (calculated from the current price) when "ReverseMode" = true.                                                   
extern bool    VirtualSL               = false; //If true - SL not installed.                                                

extern int     TakeProfit              = 60;    //+\- pips to the difference of the last indicator's support and ressistance levels.
extern bool    FixedTP                 = true;  //Absolute value of "TakeProfit" pips from the order open price.

extern int     Slippage                = 3;           
extern int     Magic                   = 0;
extern string  Coment                  = "eST";

//--------------------------------------------------------------------------------------------------
//Globals
int      gi_dg, 
         gi_lotdg,
         gi_c;
double   gd_minlot, 
         gd_maxlot, 
         gd_lotstep, 
         gd_p;

int      gi_buys, 
         gi_sells;
double   gd_buyop, 
         gd_sellop;
double   gd_buylots, 
         gd_selllots;   

int      gi_trend = -1;
int      gi_trends = -1;
int      gi_trendprev =-1;
int      gi_trendprevs =-1;
bool     gb_sig;
datetime gt_sig;
datetime gt_fm;
double   gd_longtp, 
         gd_shorttp,
         gd_longsl,
         gd_shortsl;
bool     gb_longhalf, 
         gb_shorthalf;
string   gsg_tpnm,
         gsg_slnm;
double   gd_lastlots;
int      gi_slippage;
int      zz=0,xx=0;
datetime reset;
//--------------------------------------------------------------------------------------------------
//Init
//--------------------------------------------------------------------------------------------------
int init() 
{
   gi_dg = MarketInfo(Symbol(), MODE_DIGITS);
   gd_maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   gd_minlot = MarketInfo(Symbol(), MODE_MINLOT);
   gd_lotstep = MarketInfo(Symbol(), MODE_LOTSTEP);   
   gi_lotdg = MathLog(1/gd_lotstep)/MathLog(10);
   gd_p = MarketInfo(Symbol(), MODE_POINT);
   
   gi_c = 1;
   if(gi_dg == 3 || gi_dg == 5) gi_c = 10;
   gi_slippage = Slippage * gi_c;
   StopLoss *= gi_c; 
   TakeProfit *= gi_c;
   ReverseModeSL *= gi_c;
   
   gsg_tpnm = WindowExpertName()+"_TP";
   gsg_slnm = WindowExpertName()+"_SL";
   
   return(0);
}

//--------------------------------------------------------------------------------------------------
//Deinit
//--------------------------------------------------------------------------------------------------
int deinit() {return(0);}

//--------------------------------------------------------------------------------------------------
//Start
//--------------------------------------------------------------------------------------------------
int start() {
   if(TimeDayOfYear(reset)!=DayOfYear()){ zz=0;xx=0;gi_trends = 0;}
   //Indicators data
   double res0 = iCustom(NULL,SuperTrend_TimeFrame,"xSuperTrend_MTF","","",SuperTrend_Period,SuperTrend_Multiplier,SuperTrend_TimeFrame,0,1,1);
   double sup0 = iCustom(NULL,SuperTrend_TimeFrame,"xSuperTrend_MTF","","",SuperTrend_Period,SuperTrend_Multiplier,SuperTrend_TimeFrame,0,2,1);
   double res1 = iCustom(NULL,SuperTrend_TimeFrame,"xSuperTrend_MTF","","",SuperTrend_Period,SuperTrend_Multiplier,SuperTrend_TimeFrame,0,1,2);
   double sup1 = iCustom(NULL,SuperTrend_TimeFrame,"xSuperTrend_MTF","","",SuperTrend_Period,SuperTrend_Multiplier,SuperTrend_TimeFrame,0,2,2);   
   double res3 = iCustom(NULL,SuperTrend_TimeFrame2,"xSuperTrend_MTF","","",SuperTrend_Period2,SuperTrend_Multiplier2,SuperTrend_TimeFrame2,0,0,0);
   double res4 = iCustom(NULL,SuperTrend_TimeFrame2,"xSuperTrend_MTF","","",SuperTrend_Period2,SuperTrend_Multiplier2,SuperTrend_TimeFrame2,0,0,1);
   double res5 = iCustom(NULL,SuperTrend_TimeFrame2,"xSuperTrend_MTF","","",SuperTrend_Period2,SuperTrend_Multiplier2,SuperTrend_TimeFrame2,0,0,2);
   //Trend switching
   if(gt_sig < iTime(NULL,0,0))
     {
      if(sup0 != EMPTY_VALUE && sup1 == EMPTY_VALUE && iClose(NULL,SuperTrend_TimeFrame2,0)> res3) gi_trend = 1;
   
      if(res0 != EMPTY_VALUE && res1 == EMPTY_VALUE && iClose(NULL,SuperTrend_TimeFrame2,0)< res3) gi_trend = 2; 

      if(sup0 != EMPTY_VALUE && iClose(NULL,SuperTrend_TimeFrame2,1)> res4 && iClose(NULL,SuperTrend_TimeFrame2,2)< res5){ gi_trends = 1;}
   
      if(res0 != EMPTY_VALUE && iClose(NULL,SuperTrend_TimeFrame2,1)< res4 && iClose(NULL,SuperTrend_TimeFrame2,2)> res5){ gi_trends = 2;} 
              
      if(gi_trend > 0) gt_sig =  iTime(NULL,SuperTrend_TimeFrame,0) + SuperTrend_TimeFrame;
      if(gi_trends > 0) gt_sig =  iTime(NULL,SuperTrend_TimeFrame,0) + SuperTrend_TimeFrame;
     }

   if(gi_trendprev != gi_trend) {gi_trendprev = gi_trend; gb_sig = true;}
   if(gi_trendprevs != gi_trends) {gi_trendprevs = gi_trends; gb_sig = true;}
   
   f0_orders();
   
//--------------------------------------------------------------------------------------------------   
   //CLOSE
//--------------------------------------------------------------------------------------------------      
   RefreshRates();
   
   //Buys
   if(gi_buys > 0)
   {
      if(!IsTesting()) 
      {
         if(gd_longtp == 0 && GlobalVariableCheck(gsg_tpnm)) gd_longtp = GlobalVariableGet(gsg_tpnm);
         if(gd_longsl == 0 && GlobalVariableCheck(gsg_slnm)) gd_longsl = GlobalVariableGet(gsg_slnm);
      }

      if((iClose(NULL,0,0) < sup0-StopLoss*gd_p && sup0 != EMPTY_VALUE && sup0 !=0) || (gd_longsl > 0 && iClose(NULL,0,0) < gd_longsl)) 
         f0_close(OP_BUY,false);
      if(CloseLotPercent > 0) 
         if(gb_longhalf && gd_longtp != 0 && iClose(NULL,0,0) > gd_buyop+gd_longtp) f0_close(OP_BUY,true);
      
      if(!VirtualSL && gt_fm<iTime(NULL,0,0) && sup0 != EMPTY_VALUE && sup0 !=0) 
         if(fb_modifysl(0,sup0-StopLoss*gd_p)) gt_fm = iTime(NULL,0,0);
   }
   else 
   {
      gd_longtp = 0; gb_longhalf = false; 
      gd_longsl = 0;
   }
   
   //Sells
   if(gi_sells > 0)
   {
      if(!IsTesting()) 
      {
         if(gd_shorttp == 0 && GlobalVariableCheck(gsg_tpnm)) gd_shorttp = GlobalVariableGet(gsg_tpnm);   
         if(gd_shortsl == 0 && GlobalVariableCheck(gsg_slnm)) gd_shortsl = GlobalVariableGet(gsg_slnm);   
      }

      if((iClose(NULL,0,0) > res0+StopLoss*gd_p && res0 != EMPTY_VALUE && res0 !=0) || (gd_shortsl > 0 && iClose(NULL,0,0) > gd_shortsl)) 
         f0_close(OP_SELL,false);   
      if(CloseLotPercent > 0) 
         if(gb_shorthalf && gd_shorttp != 0 && iClose(NULL,0,0) < gd_sellop-gd_shorttp) f0_close(OP_SELL,true);

      if(!VirtualSL && gt_fm<iTime(NULL,0,0) && res0 != EMPTY_VALUE && res0 !=0) 
         if(fb_modifysl(1,res0+StopLoss*gd_p)) gt_fm = iTime(NULL,0,0);
   }
   else
   {
      gd_shorttp = 0; gb_shorthalf = false;
      gd_shortsl = 0;
   }
   
//--------------------------------------------------------------------------------------------------   
   //Delete gvs
   if(gi_buys < 1 && gi_sells < 1) 
   {
      if(GlobalVariableCheck(gsg_tpnm)) GlobalVariableDel(gsg_tpnm);
      if(GlobalVariableCheck(gsg_slnm)) GlobalVariableDel(gsg_slnm);
   }
   
//--------------------------------------------------------------------------------------------------
   //OPEN
//--------------------------------------------------------------------------------------------------   
   if((gi_trend > 0 || gi_trends > 0) && gb_sig)
   {
      RefreshRates();
      int ty = -1;
      double sl; 
      
      //Long
      if(gi_trend == 1 && iClose(NULL,0,0) > fd_last(0) && gi_buys < 1)  
      {
         ty = 0; sl = sup0 - StopLoss * gd_p;
         if(ReverseMode) {ty = 1; sl = Bid + ReverseModeSL * gd_p;}
      }
      if(gi_trends == 1 && iClose(NULL,0,0) > fd_last(0) && gi_buys < 1 && zz==0)  
      {
         ty = 0; sl = sup0 - StopLoss * gd_p;zz=1;reset=TimeCurrent(); 
         if(ReverseMode) {ty = 1; sl = Bid + ReverseModeSL * gd_p;}
      }      
      
      //Short
      if(gi_trend == 2 && iClose(NULL,0,0) < fd_last(0) && gi_sells < 1) 
      {
         ty = 1; sl = res0+StopLoss*gd_p;
         if(ReverseMode) {ty = 0; sl = Ask - ReverseModeSL * gd_p;}         
      }
      if(gi_trends == 2 && iClose(NULL,0,0) < fd_last(0) && gi_sells < 1 && xx==0) 
      {
         ty = 1; sl = res0+StopLoss*gd_p;xx=1;reset=TimeCurrent();
         if(ReverseMode) {ty = 0; sl = Ask - ReverseModeSL * gd_p;}         
      }
            
      double lots = fd_lots(0);
      if(LotMultiplier > 0 && fd_ordersprofit(CalcHistOrders) < 0) lots = LotMultiplier * gd_lastlots;
      if(ty >= 0) fi_open(ty, fd_lots(lots),sl,0);
   }   
   
   return(0);
}

//--------------------------------------------------------------------------------------------------
//UDF
//--------------------------------------------------------------------------------------------------
void f0_close(int ty=-1, bool half=false) 
{
   if(IsTradeContextBusy()) return;
   for (int i=OrdersTotal()-1; i>=0; i--) 
   {
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic || OrderType() != ty) continue;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == ty) 
      {
         double pr; 
         color cl;
         double vol = OrderLots();
         if(half && (gb_shorthalf || gb_longhalf) && CloseLotPercent > 0) vol = fd_lots(vol*CloseLotPercent/100);
         if(vol < gd_minlot) vol = OrderLots();
         
         RefreshRates();
         if(OrderType()==OP_BUY) {pr=MarketInfo(Symbol(),MODE_BID); cl=Blue;}
         else                    {pr=MarketInfo(Symbol(),MODE_ASK); cl=Red;}
         if(IsTradeContextBusy()) {i++; continue;}                  
         
         if(!OrderClose(OrderTicket(),vol,fd_nd(pr,gi_dg),gi_slippage,cl)) 
            Print("Order "+fs_op(ty)+" CLOSE error: "+GetLastError());
         else 
         {
            if(gb_longhalf) gb_longhalf = false;
            if(gb_shorthalf) gb_shorthalf = false;
         }
      }
   }
}

//--------------------------------------------------------------------------------------------------
int fi_open(int ty=-1, double lo=0, double sl=0, double tp=0)
{
   if(IsTradeContextBusy()) return(0);
   int tic;
   color cl;
   double pr;
   bool res;
   for (int i = 0; i < 100; i++)
   {
      while(!IsTradeContextBusy()) 
      {
         double lev=MathMax(MarketInfo(Symbol(),MODE_FREEZELEVEL),MarketInfo(Symbol(),MODE_STOPLEVEL))*gd_p;
         RefreshRates();
         if(ty == OP_BUY)  
         {
            pr = MarketInfo(Symbol(),MODE_ASK); cl = Blue; 
            if(sl > 0 && fd_nd(pr-sl,gi_dg) < fd_nd(lev,gi_dg)) sl = pr - lev;
         } 
         
         if(ty == OP_SELL) 
         {
            pr = MarketInfo(Symbol(),MODE_BID); cl = Red;
            if(sl > 0 && fd_nd(sl-pr,gi_dg) < fd_nd(lev,gi_dg)) sl = pr + lev;
         }
         double vsl;
         if(ReverseMode && VirtualSL) vsl = sl;
         if(VirtualSL) sl = 0;   
         
         tic = OrderSend(Symbol(),ty,lo,fd_nd(pr,gi_dg),gi_slippage,fd_nd(sl,gi_dg),fd_nd(tp,gi_dg),Coment,Magic,0,cl);
         int er = GetLastError();
         if(er > 0) 
         {
            Print("Order "+fs_op(ty)+" OPEN error: "+er);            
            if(!(er==4 || er==136 || er==137 || er==146)) return(0);
            Sleep(5000);
         }
         else 
         {
            res = true;
            gi_trend = 0; gb_sig = false;gi_trends=0; 
            double dif = (fd_last(1) - fd_last(2)) + TakeProfit * gd_p;
            if(FixedTP) dif = MathAbs(TakeProfit)* gd_p;
            if(dif < lev) dif = lev;
            if(!IsTesting()){
               GlobalVariableSet(WindowExpertName()+"_TP",fd_nd(dif,gi_dg));
               if(vsl > 0) GlobalVariableSet(WindowExpertName()+"_SL",fd_nd(vsl,gi_dg));
            }
            if(ty == 0) {gd_longtp  = dif; gb_longhalf = true;  if(vsl>0) gd_longsl = vsl;}
            if(ty == 1) {gd_shorttp = dif; gb_shorthalf = true; if(vsl>0) gd_shortsl= vsl;}
            break;
         }
      }
      if(res) break;
   }
   return(tic);
}

//--------------------------------------------------------------------------------------------------
double fd_nd(double val, int dg) {return(NormalizeDouble(val,dg));}

//--------------------------------------------------------------------------------------------------
string fs_ds(double val, int dg) {return(DoubleToStr(val,dg));}

//--------------------------------------------------------------------------------------------------
string fs_op(int op) 
{
   switch (op) 
   {
      case  0: return("OP_BUY");
      case  1: return("OP_SELL");
      case  2: return("OP_BUYLIMIT");
      case  3: return("OP_SELLLIMIT");
      case  4: return("OP_BUYSTOP");
      case  5: return("OP_SELLSTOP");
      default: return("OP_WRONG");
   }
}

//--------------------------------------------------------------------------------------------------
double fd_lots(double lots) {
   if(MaxLot > gd_maxlot) MaxLot = gd_maxlot;

   //
   double fre = AccountFreeMargin();      
   double req = MarketInfo(Symbol(),MODE_MARGINREQUIRED);      
   if(lots > 0) lots = fd_nd(lots,gi_lotdg);
   else
   if(RiskPercent <= 0)  lots = Lots;               
   else {                                   
      double m;
      if(UseEquity) m = AccountEquity();
      else m = AccountBalance();
      lots = fd_nd(m*RiskPercent/100/req, gi_lotdg);
   }

   if(lots < gd_minlot) lots = gd_minlot;
   if(MaxLot > 0 && lots > MaxLot) lots = MaxLot;
   if(lots * req > fre) {
      Print("Not enough money for lot : "+fs_ds(lots,gi_lotdg)+"!"); 
      lots = fd_nd(fre/req-gd_minlot,gi_lotdg);
      if(lots < gd_minlot) return(0);
   }
   return(lots);
}

//--------------------------------------------------------------------------------------------------
bool fb_modifysl(int ty, double sl)
{
   bool res;
   color cl;
   for (int i=OrdersTotal()-1; i>=0; i--) 
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
         if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic || (OrderType() != ty || OrderType() > 1)) continue;
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == ty) 
         {
            RefreshRates();
            int lev=MathMax(MarketInfo(Symbol(),MODE_FREEZELEVEL),MarketInfo(Symbol(),MODE_STOPLEVEL));
            double pr, sl0 = OrderStopLoss();                        
            res = false;
            switch(OrderType())
            {
               case OP_BUY:   
               {
                  pr = MarketInfo(Symbol(),MODE_BID); cl=DodgerBlue; 
                  if(fd_nd((pr-sl)/gd_p,0) >= lev && (fd_nd((sl-sl0)/gd_p,0) >=1 || fd_nd(sl0,gi_dg)==0))
                     res = OrderModify(OrderTicket(),OrderOpenPrice(),fd_nd(sl,gi_dg),0,0,cl);
                  break;
               }
               
               case OP_SELL:  
               {
                  pr = MarketInfo(Symbol(),MODE_ASK); cl=PaleVioletRed; 
                  if(fd_nd((sl-pr)/gd_p,0) >= lev && (fd_nd((sl0-sl)/gd_p,0) > 1 || fd_nd(sl0,gi_dg)==0))
                     res = OrderModify(OrderTicket(),OrderOpenPrice(),fd_nd(sl,gi_dg),0,0,cl);                   
                  break;
               }
               
               if(!res) 
               {
                  int er = GetLastError();
                  Print("Order "+fs_op(ty)+" MODIFY error: "+er);
                  if(!(er==4 || er==136 || er==137 || er==146)) return(0);
                  Sleep(5000);            
                  i++; continue;
               }
               else break;
            }
         }
      }
   }
   return(res);
}

//--------------------------------------------------------------------------------------------------
double fd_last(int index=-1)
{
   double val;
   for(int i=0; i<1000; i++)
   {
      double cur = iCustom(NULL,SuperTrend_TimeFrame,"xSuperTrend_MTF","","",SuperTrend_Period,SuperTrend_Multiplier,SuperTrend_TimeFrame,0, index, i);   
      if(cur != EMPTY_VALUE && cur != 0) {val = cur; break;}
   }
   return(val);
}

//--------------------------------------------------------------------------------------------------
void f0_orders() 
{
   gi_buys=0; gi_sells=0;
   gd_buyop=0; gd_sellop=0;
   gd_buylots=0; gd_selllots=0;   
   for (int i=OrdersTotal()-1; i>=0; i--) 
   {
      bool os=OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic || OrderType() > 1) continue;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
      {
         if(OrderType() == OP_BUY) 
         {
            gi_buys++;
            gd_buyop = OrderOpenPrice();
            gd_buylots = OrderLots();
            break;
         }
         if(OrderType() == OP_SELL) 
         {
            gi_sells++;
            gd_sellop = OrderOpenPrice();
            gd_selllots = OrderLots();
            break;
         }         
      }
   }
   return;
}

//--------------------------------------------------------------------------------------------------
double fd_ordersprofit(int count)
{
   if(count == 0) count = 1;
   gd_lastlots = 0;
   double profit;
   for(int i=OrdersHistoryTotal()-1; i>=0; i--) 
   {   
      bool os=OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic || OrderType() > 1) continue;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && (OrderType()==0 || OrderType()==1)) 
      {
         double pro = OrderProfit();
         if(count > 0) {
            profit += pro;    count--; 
            if(profit < 0) gd_lastlots += OrderLots(); 
         }
         else break;
      }
   }
   return(profit);
}

//--------------------------------------------------------------------------------------------------